Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time
Class DurationField

    java.lang.Object
      org.joda.time.DurationField

All Implemented Interfaces:
  java.lang.Comparable

Direct Known Subclasses:
  BaseDurationField, DelegatedDurationField, MillisDurationField, UnsupportedDurationField

    public abstract class DurationField

extends java.lang.Object
implements java.lang.Comparable

Defines the calculation engine for duration fields. The interface defines a set of methods that manipulate a millisecond duration with regards to a single field, such as months or seconds.

This design is extensible so, if you wish, you can extract a different field from the millisecond duration. A number of standard implementations are provided to assist.

Since:
  1.0
Author:
  Stephen Colebourne, Brian S O'Neill

Constructor Summary
`DurationField()`

Method Summary
`abstract long` | `add(long instant, int value)` Adds a duration value (which may be negative) to the instant.
`abstract long` | `add(long instant, long value)` Adds a duration value (which may be negative) to the instant.
`abstract int` | `compareTo(java.lang.Object durationField)` Compares this duration field with another duration field for ascending unit millisecond order.
`abstract int` | `getDifference(long minuendInstant, long subtrahendInstant)` Computes the difference between two instants, as measured in the units of this field.
`abstract long` | `getDifferenceAsLong(long minuendInstant, long subtrahendInstant)` Computes the difference between two instants, as measured in the units of this field.
`abstract long` | `getMillis(int value)` Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.
`abstract long` | `getMillis(int value, long instant)` Get the millisecond duration of this field from its value relative to an instant.
`abstract long` | `getMillis(long value)` Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.
`abstract long` | `getMillis(long value, long instant)` Get the millisecond duration of this field from its value relative to an instant.
`abstract java.lang.String` | `getName()` Get the name of the field.
`abstract DurationFieldType` | `getType()` Get the type of the field.
`abstract long` | `getUnitMillis()` Returns the amount of milliseconds per unit value of this field.
`abstract int` | `getValue(long duration)` Get the value of this field from the milliseconds, which is approximate if this field is imprecise.
`abstract int` | `getValue(long duration, long instant)` Get the value of this field from the milliseconds relative to an instant.
`abstract long` | `getValueAsLong(long duration)` Get the value of this field from the milliseconds, which is approximate if this field is imprecise.
`abstract long` | `getValueAsLong(long duration, long instant)` Get the value of this field from the milliseconds relative to an instant.
`abstract boolean` | `isPrecise()` Is this field precise.
`abstract boolean` | `isSupported()` Returns true if this field is supported.
`long` | `subtract(long instant, int value)` Subtracts a duration value (which may be negative) from the instant.
`long` | `subtract(long instant, long value)` Subtracts a duration value (which may be negative) from the instant.
`abstract java.lang.String` | `toString()` Get a suitable debug string.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DurationField

    public DurationField()

Method Detail

### getType

    public abstract DurationFieldType getType()

  Get the type of the field.

  Returns:
    field type

### getName

    public abstract java.lang.String getName()

  Get the name of the field.

  By convention, names are plural.

  Returns:
    field name

### isSupported

    public abstract boolean isSupported()

  Returns true if this field is supported.

  Returns:
    true if this field is supported

### isPrecise

    public abstract boolean isPrecise()

  Is this field precise. A precise field can calculate its value from milliseconds without needing a reference date. Put another way, a precise field's unit size is not variable.

  Returns:
    true if precise
  See Also:
    `getUnitMillis()`

### getUnitMillis

    public abstract long getUnitMillis()

  Returns the amount of milliseconds per unit value of this field. For example, if this field represents "seconds", then this returns the milliseconds in one second.

  For imprecise fields, the unit size is variable, and so this method returns a suitable average value.

  Returns:
    the unit size of this field, in milliseconds
  See Also:
    `isPrecise()`

### getValue

    public abstract int getValue(long duration)

  Get the value of this field from the milliseconds, which is approximate if this field is imprecise.

  Parameters:
    `duration` - the milliseconds to query, which may be negative
  Returns:
    the value of the field, in the units of the field, which may be negative
  Throws:
    `java.lang.ArithmeticException` - if the value is too large for an int

### getValueAsLong

    public abstract long getValueAsLong(long duration)

  Get the value of this field from the milliseconds, which is approximate if this field is imprecise.

  Parameters:
    `duration` - the milliseconds to query, which may be negative
  Returns:
    the value of the field, in the units of the field, which may be negative

### getValue

    public abstract int getValue(long duration,
                                 long instant)

  Get the value of this field from the milliseconds relative to an instant. For precise fields this method produces the same result as for the single argument get method.

  If the millisecond duration is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Parameters:
    `duration` - the milliseconds to query, which may be negative
    `instant` - the start instant to calculate relative to
  Returns:
    the value of the field, in the units of the field, which may be negative
  Throws:
    `java.lang.ArithmeticException` - if the value is too large for an int

### getValueAsLong

    public abstract long getValueAsLong(long duration,
                                        long instant)

  Get the value of this field from the milliseconds relative to an instant. For precise fields this method produces the same result as for the single argument get method.

  If the millisecond duration is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Parameters:
    `duration` - the milliseconds to query, which may be negative
    `instant` - the start instant to calculate relative to
  Returns:
    the value of the field, in the units of the field, which may be negative

### getMillis

    public abstract long getMillis(int value)

  Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.

  Parameters:
    `value` - the value of the field, which may be negative
  Returns:
    the milliseconds that the field represents, which may be negative

### getMillis

    public abstract long getMillis(long value)

  Get the millisecond duration of this field from its value, which is approximate if this field is imprecise.

  Parameters:
    `value` - the value of the field, which may be negative
  Returns:
    the milliseconds that the field represents, which may be negative

### getMillis

    public abstract long getMillis(int value,
                                   long instant)

  Get the millisecond duration of this field from its value relative to an instant. For precise fields this method produces the same result as for the single argument getMillis method.

  If the value is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Parameters:
    `value` - the value of the field, which may be negative
    `instant` - the instant to calculate relative to
  Returns:
    the millisecond duration that the field represents, which may be negative

### getMillis

    public abstract long getMillis(long value,
                                   long instant)

  Get the millisecond duration of this field from its value relative to an instant. For precise fields this method produces the same result as for the single argument getMillis method.

  If the value is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Parameters:
    `value` - the value of the field, which may be negative
    `instant` - the instant to calculate relative to
  Returns:
    the millisecond duration that the field represents, which may be negative

### add

    public abstract long add(long instant,
                             int value)

  Adds a duration value (which may be negative) to the instant.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to add to
    `value` - the value to add, in the units of the field
  Returns:
    the updated milliseconds

### add

    public abstract long add(long instant,
                             long value)

  Adds a duration value (which may be negative) to the instant.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to add to
    `value` - the value to add, in the units of the field
  Returns:
    the updated milliseconds

### subtract

    public long subtract(long instant,
                         int value)

  Subtracts a duration value (which may be negative) from the instant.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `value` - the value to subtract, in the units of the field
  Returns:
    the updated milliseconds
  Since:
    1.1

### subtract

    public long subtract(long instant,
                         long value)

  Subtracts a duration value (which may be negative) from the instant.

  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `value` - the value to subtract, in the units of the field
  Returns:
    the updated milliseconds
  Since:
    1.1

### getDifference

    public abstract int getDifference(long minuendInstant,
                                      long subtrahendInstant)

  Computes the difference between two instants, as measured in the units of this field. Any fractional units are dropped from the result. Calling getDifference reverses the effect of calling add. In the following code:

       long instant = ...
       int v = ...
       int age = getDifference(add(instant, v), instant);

  The value 'age' is the same as the value 'v'.

  Parameters:
    `minuendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `subtrahendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract off the minuend
  Returns:
    the difference in the units of this field

### getDifferenceAsLong

    public abstract long getDifferenceAsLong(long minuendInstant,
                                             long subtrahendInstant)

  Computes the difference between two instants, as measured in the units of this field. Any fractional units are dropped from the result. Calling getDifference reverses the effect of calling add. In the following code:

       long instant = ...
       long v = ...
       long age = getDifferenceAsLong(add(instant, v), instant);

  The value 'age' is the same as the value 'v'.

  Parameters:
    `minuendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `subtrahendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract off the minuend
  Returns:
    the difference in the units of this field

### compareTo

    public abstract int compareTo(java.lang.Object durationField)

  Compares this duration field with another duration field for ascending unit millisecond order. This ordering is inconsistent with equals, as it ignores name and precision.

  Specified by:
    `compareTo` in interface `java.lang.Comparable`
  Parameters:
    `durationField` - a duration field to check against
  Returns:
    negative value if this is less, 0 if equal, or positive value if greater
  Throws:
    `java.lang.NullPointerException` - if the object is null
    `java.lang.ClassCastException` - if the object type is not supported

### toString

    public abstract java.lang.String toString()

  Get a suitable debug string.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    debug string

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD